import { Logger } from '@arsonar/common';
import type EventSource from 'eventsource';
import type { Workspace } from './workspace';
import { FetchOpts } from './fetch';
import { Collection } from './collection';
export interface Reply {
    requestId: string;
    error?: any;
    result?: any;
}
export interface BotMessage {
    bot: string;
    op: string;
    data?: any;
    requestId: string;
}
export declare class Bots {
    workspace: Workspace;
    bots: Map<string, Bot>;
    log: Logger;
    _eventSource?: EventSource;
    _init?: boolean;
    _sessionId?: string;
    constructor(workspace: Workspace);
    close(): Promise<void>;
    join(botName: string, collection: string): Promise<any>;
    leave(botName: string, collection: string): Promise<any>;
    info(): Promise<any>;
    command(botName: string, command: string, args: any, env: any): Promise<any>;
    commandStatus(botName: string, requestId: string): Promise<any>;
    getCommands(): Promise<void>;
    _initListener(): Promise<void>;
    reply({ requestId, error, result }: Reply): Promise<any>;
    _onmessage(message: any): Promise<void>;
    getHeaders(): Record<string, string>;
    fetch(url: string, opts?: FetchOpts): Promise<any>;
    register(name: string, spec: any, handlers: any): Promise<void>;
}
declare class Bot {
    spec: any;
    name: string;
    workspace: Workspace;
    config: any;
    handlers: any;
    opened: boolean;
    log: Logger;
    opening: any;
    sessions: Map<string, any>;
    constructor({ spec, config, handlers, workspace }: any);
    open(): Promise<any>;
    onjoin(collection: Collection, config: any): Promise<void>;
    _ensureTypes(collection: Collection): Promise<void>;
    onleave(collection: Collection): Promise<void>;
    oncommand(command: string, args: any, env: any): Promise<any>;
}
export {};
//# sourceMappingURL=bots.d.ts.map